/* itplbv.c -- translated by f2c
 
   itplbv is part of ACM algorithm 474 by H. Akima,
   Bivariate interpolation and smooth surface fitting
   based on local procedures.
   Paper: A method of bivariate interpolation and 
   smooth surface fitting based on local procedures.
   Communications of the ACM 17, 1(Jan.1974), 18-20.

  modified and extended by A.Preusser */

/* f2c.h  --  Standard Fortran to C header file */

typedef int integer;
typedef char *address;
typedef short int shortint;
typedef float real;
typedef double doublereal;
typedef struct { real r, i; } complex;
typedef struct { doublereal r, i; } doublecomplex;
typedef long int logical;
typedef short int shortlogical;

#define TRUE_ (1)
#define FALSE_ (0)

#define VOID void

#define abs(x) ((x) >= 0 ? (x) : -(x))
#define dabs(x) (doublereal)abs(x)
#define min(a,b) ((a) <= (b) ? (a) : (b))
#define max(a,b) ((a) >= (b) ? (a) : (b))
#define dmin(a,b) (doublereal)min(a,b)
#define dmax(a,b) (doublereal)max(a,b)

/* undef any lower-case symbols that your C compiler predefines, e.g.: */

#undef cray
#undef gcos
#undef mc68010
#undef mc68020
#undef mips
#undef pdp11
#undef sgi
#undef sparc
#undef sun
#undef sun2
#undef sun3
#undef sun4
#undef u370
#undef u3b
#undef u3b2
#undef u3b5
#undef unix
#undef vax

#include <stdio.h>
/* #include <X11/Intrinsic.h>	
#include <X11/StringDefs.h>
#include <X11/Xlib.h> */
/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int itplbv_(itask, lx, ly, x, y, z, n,
                             cn, icol, nc,
                             u, v, w, wx, wy)
int *itask, *nc, *icol;
integer *lx, *ly;
real *x, *y, *z, *cn;
integer *n;
real *u, *v, *w, *wx, *wy;
{
    /* Format strings */
    static char fmt_9000[] = "(1x,/,\002   ***   LX=1 OR LESS./\002)";
    static char fmt_9010[] = "(1x,/,\002   ***   LY=1 OR LESS./\002)";
    static char fmt_9020[] = "(1x,/,\002   ***   N=0 OR LESS./\002)";
    static char fmt_9070[] = "(1x,/,\002  ***   Y VALUES OUT OF SEQUENCE.\
\002,/)";
    static char fmt_9060[] = "(1x,/,\002  ***   IDENTICAL Y VALUES.\002,/)";
    static char fmt_9080[] = "(\002   IY =\002,i6,10x,\002Y(IY) =\002,e12.3)";

    static char fmt_9040[] = "(1x,/,\002  ***   X VALUES OUT OF SEQUENCE.\
\002,/)";
    static char fmt_9030[] = "(1x,/,\002  ***   IDENTICAL X VALUES.\002,/)";
    static char fmt_9050[] = "(\002   IX =\002,i6,10x,\002X(IX) =\002,e12.3)";

    static char fmt_9090[] = "(\002   LX =\002,i6,10x,\002LY =\002,i6,10x\
,\002N =\002,i7,/,\002 ERROR DETECTED IN ROUTINE    ITPLBV\002)";

    /* System generated locals */
    integer z_dim1, z_offset, i__1;
    real r__1;
    static real equiv_9[10], equiv_19[10], equiv_28[9], equiv_41[1];
    static integer equiv_57[1], equiv_58[1], equiv_59[1], equiv_60[1];
    static real equiv_61[1], equiv_62[1], equiv_73[16], equiv_78[16], 
	    equiv_85[1], equiv_86[1], equiv_88[16];

static real xx[4], yy[4], zz[4], zzx[4], zzy[4], zzxy[4];
static integer nsides;
static integer rect_counter=0;

    extern int usrpsc_();

    /* Local variables */
#define za2b2 (equiv_28)
#define za3b2 (equiv_28 + 1)
#define za4b2 (equiv_28 + 2)
#define za2b3 (equiv_28 + 3)
#define za3b3 (equiv_28 + 4)
#define za4b3 (equiv_28 + 5)
#define za2b4 (equiv_28 + 6)
#define za3b4 (equiv_28 + 7)
#define za4b4 (equiv_28 + 8)
    static real zx3b3;
    static integer jxml, jyml;
    static real zx4b3, zy3a3, zy4a3;
#define ixpv ((integer *)equiv_88 + 12)
#define iypv ((integer *)equiv_88 + 15)
#define zxy33 (equiv_88 + 5)
#define zxy43 (equiv_88 + 6)
#define zxy34 (equiv_88 + 9)
#define zxy44 (equiv_88 + 10)
#define a (equiv_73 + 1)
#define b (equiv_73 + 4)
#define c (equiv_73 + 7)
#define d (equiv_78 + 1)
#define e (equiv_78 + 13)
    static integer k;
#define a1 (equiv_73 + 1)
#define b1 (equiv_73 + 1)
#define a2 (equiv_73 + 4)
#define a4 (equiv_73 + 7)
#define a5 (equiv_73 + 1)
#define b5 (equiv_73 + 1)
#define b2 (equiv_78 + 1)
#define b4 (equiv_78 + 13)
    static real a3, b3;
    static integer n0;
#define q0 (equiv_73 + 1)
#define q1 (equiv_73 + 4)
#define q2 (equiv_73 + 7)
#define q3 (equiv_78 + 1)
    static real r0, r1, r2;
#define w1 (equiv_86)
#define w2 (equiv_85)
#define x2 (equiv_73 + 2)
#define y2 (equiv_73 + 13)
#define x4 (equiv_73 + 8)
#define x5 (equiv_73 + 11)
#define y4 (equiv_78 + 2)
#define y5 (equiv_73 + 14)
#define w4 (equiv_85)
#define w3 (equiv_86)
#define w5 (equiv_86)
    static real x3, y3, s0, s1, s2;
#define p00 (equiv_41)
#define p01 (equiv_78 + 5)
#define p10 (equiv_73 + 5)
#define p11 (equiv_88 + 5)
#define p02 (equiv_73 + 14)
#define p03 (equiv_78 + 4)
#define p12 (equiv_78 + 7)
#define p13 (equiv_78 + 8)
#define p20 (equiv_78 + 11)
#define p21 (equiv_78 + 14)
#define p22 (equiv_88 + 1)
#define za (equiv_9)
#define zb (equiv_19)
#define dx (equiv_61)
#define dy (equiv_62)
#define z33 (equiv_41)
#define ix ((integer *)equiv_88)
#define iy ((integer *)equiv_88 + 3)
#define jx (equiv_57)
#define jy (equiv_58)
#define uk (equiv_61)
#define vk (equiv_62)
#define z23 (equiv_78 + 4)
#define z24 (equiv_78 + 7)
#define z32 (equiv_78 + 8)
#define z34 (equiv_78 + 11)
#define z35 (equiv_78 + 14)
#define z42 (equiv_88 + 1)
#define z43 (equiv_88 + 4)
#define zx (equiv_73)
#define zy (equiv_78)
#define p23 (equiv_88 + 4)
#define z44 (equiv_88 + 2)
#define p30 (equiv_88 + 2)
#define z45 (equiv_88 + 7)
#define p31 (equiv_88 + 7)
#define z53 (equiv_88 + 8)
#define p32 (equiv_88 + 8)
#define z54 (equiv_88 + 11)
#define p33 (equiv_88 + 11)
    static real sw;
    static integer itas;
#define jx1 (equiv_59)
#define lx0 ((integer *)equiv_73)
#define ly0 ((integer *)equiv_78)
#define jy1 (equiv_60)
    static real qq1, qq2, qq3;
#define wx2 (equiv_88 + 13)
#define wy2 (equiv_85)
#define wy3 (equiv_86)
#define wx3 (equiv_88 + 14)
#define zab (equiv_28)
#define z3a1 (equiv_9)
#define z3a2 (equiv_9 + 1)
#define z3a3 (equiv_9 + 2)
#define z3a4 (equiv_9 + 3)
#define z3a5 (equiv_9 + 4)
#define z4a1 (equiv_9 + 5)
#define z4a2 (equiv_9 + 6)
#define z4a3 (equiv_9 + 7)
#define z4a4 (equiv_9 + 8)
#define z4a5 (equiv_9 + 9)
#define z3b1 (equiv_19)
#define z3b2 (equiv_19 + 2)
#define z3b3 (equiv_19 + 4)
#define z3b4 (equiv_19 + 6)
#define z3b5 (equiv_19 + 8)
#define z4b1 (equiv_19 + 1)
#define z4b2 (equiv_19 + 3)
#define z4b3 (equiv_19 + 5)
#define z4b4 (equiv_19 + 7)
#define z4b5 (equiv_19 + 9)
#define imn (equiv_57)
#define imx (equiv_58)
#define zx33 (equiv_73 + 5)
#define zx43 (equiv_73 + 6)
#define zx34 (equiv_73 + 9)
#define zx44 (equiv_73 + 10)
#define zy33 (equiv_78 + 5)
#define zy43 (equiv_78 + 6)
#define zy34 (equiv_78 + 9)
#define zy44 (equiv_78 + 10)
#define zxy (equiv_88)
#define a3sq (equiv_73 + 2)
#define b3sq (equiv_78 + 2)
#define jxm2 (equiv_59)
#define lxm1 ((integer *)equiv_73 + 3)
#define lxm2 ((integer *)equiv_73 + 12)
#define lym1 ((integer *)equiv_78 + 3)
#define lxp1 ((integer *)equiv_73 + 15)
#define lym2 ((integer *)equiv_78 + 12)
#define lyp1 ((integer *)equiv_78 + 15)
#define jym2 (equiv_60)


/*       BIVARIATE INTERPOLATION */
/*       THIS SUBROUTINE INTERPOLATES FROM VALUES OF THE FUNCTION */
/*       GIVEN AT INPUT GRIS POINTS IN AN X-Y PLANE AND FOR A GIVEN */
/*       SET OF POINTS IN THE PLANE, THE VALUES OF A SINGLE-VALUED */
/*       BIVARIATE FUNCTION Z= Z(X,Y). */
/*       THE METHOD IS BASED ON A PIECEWISE FUNCTION COMPOSED OF */
/*       A SET OF BICUBIC POLYNOMIALS IN X AND Y. EACH POLYNOMIAL */
/*       IS APPLICABLE TO A RECTANGLE OF THE INPUT GRID IN THE X-Y */
/*       PLANE. EACH POLYNOMIAL IS DETERMINED LOCALLY. */
/*       THE INPUT PARAMETERS ARE */
/* itask  = -100 single point evaluation */
/*          other values start FARBRC and are passed as MODE */
/* LX  = NUMBER OF INPUT GRID POINTS IN THE X- COORDINATE */
/*       (MUST BE 2 OR GREATER) */
/* LY  = NUMBER OF INPUT GRID POINTS IN THE Y COORDINATE */
/*       (MUST BE 2 OR GREATER) */
/* X   = ARRAY OF DIMENSION LX STORING THE X-COORDINATES */
/*       OF INPUT GRID POINTS IN ASCENDING ORDER */
/* Y   = ARRAY OF DIMENSION LY STORING THE Y-COORDINATES */
/*       OF INPUT GRID POINTS IN ASCENDING ORDER */
/* Z   = DOUBLY-DIMENSIONED ARRAY OF DIMENSION (LX,LY) */
/*       STORING THE VALUES OF THE FUNCTION AT INPUT GRID POINTS */
/* N   = NUMBER OF POINTS AT WHICH INTERPOLATION OF THE */
/*       Z VALUE IS DESIRED (>=1) */
/* cn    Contour levels
   icol  colors for levels
   nc    number of contour levels */
/* U   = ARRAY OF DIMENSION N STORING THE X-COORDINATES */
/*       OF DESIRED POINTS */
/* V   = ARRAY OF DIMENSION N STORING THE Y-COORDINATES */
/*       OF DESIRED POINTS */
/* THE OUTPUT PARAMETER IS: */
/* W   = ARRAY OF DIMENSION N WHERE THE INTERPOLATED Z-VALUES */
/*       AT DESIRED POINTS ARE TO BE DISPLAYED */
/* wx, wy first derivatives in direction of x and y */

/* DECLARATION STATEMENTS */

/*  PRELIMINARY PROCESSING */
/*  SETTING OF SOME INPUT PARAMETERS TO LOCAL VARIABLES */

    /* Parameter adjustments */
    --wy;
    --wx;
    --w;
    --v;
    --u;
    z_dim1 = *lx;
    z_offset = z_dim1 + 1;
    z -= z_offset;
    --y;
    --x;

    /* Function Body */
    itas = *itask;
    *lx0 = *lx;
    *lxm1 = *lx0 - 1;
    *lxm2 = *lxm1 - 1;
    *lxp1 = *lx0 + 1;
    *ly0 = *ly;
    *lym1 = *ly0 - 1;
    *lym2 = *lym1 - 1;
    *lyp1 = *ly0 + 1;
    n0 = *n;

/*  ERROR CHECK */

    if (*lxm2 < 0) {

/*  ERROR EXIT */
        fprintf (stderr,fmt_9000);
    } else if (*lym2 < 0) {
        fprintf (stderr,fmt_9010);
    } else if (n0 < 1) {
        fprintf (stderr,fmt_9020);
    } else {
	i__1 = *lx0;
	for (*ix = 2; *ix <= i__1; ++(*ix)) {
	    if ((r__1 = x[*ix - 1] - x[*ix]) < (float)0.) {
		goto L10;
	    } else if (r__1 == 0) {
		goto L20;
	    } else {
		goto L30;
	    }
L10:
	    ;
	}
	i__1 = *ly0;
	for (*iy = 2; *iy <= i__1; ++(*iy)) {
	    if ((r__1 = y[*iy - 1] - y[*iy]) < (float)0.) {
		goto L40;
	    } else if (r__1 == 0) {
		goto L50;
	    } else {
		goto L60;
	    }
L40:
	    ;
	}

/*  INITIAL SETTING OF PREVIOUS VALUES OF IX AND IY */

	*ixpv = 0;
	*iypv = 0;

/*  MAIN DO LOOP */

	i__1 = n0;
	for (k = 1; k <= i__1; ++k) {
	    *uk = u[k];
	    *vk = v[k];

/*  ROUTINES TO LOCATE THE DESIRED POINT */
/*  TO FIND OUT THE IX VALUE FOR WHICH */
/*  (U(K).GE.X(IX-1)).AND.(U(K).LT.X(IX)) */

	    if (*lxm2 == 0) {
		*ix = 2;
	    } else if (*uk >= x[*lx0]) {
		*ix = *lxp1;
	    } else if (*uk < x[1]) {
		*ix = 1;
	    } else {
		*imn = 2;
		*imx = *lx0;
L80:
		*ix = (*imn + *imx) / 2;
		if (*uk >= x[*ix]) {
		    *imn = *ix + 1;
		} else {
		    *imx = *ix;
		}
		if (*imx > *imn) {
		    goto L80;
		}
		*ix = *imx;
	    }

/*  TO FIND OUT THE IY VALUE FOR WHICH */
/*  (V(K).GE.Y(IY-1)).AND.(V(K).LT.Y(IY)) */

	    if (*lym2 == 0) {
		*iy = 2;
	    } else if (*vk >= y[*ly0]) {
		*iy = *lyp1;
	    } else if (*vk < y[1]) {
		*iy = 1;
	    } else {
		*imn = 2;
		*imx = *ly0;
L90:
		*iy = (*imn + *imx) / 2;
		if (*vk >= y[*iy]) {
		    *imn = *iy + 1;
		} else {
		    *imx = *iy;
		}
		if (*imx > *imn) {
		    goto L90;
		}
		*iy = *imx;
	    }

/*  TO CHECK IF THE DESIRED POINT IS IN THE SAME RECTANGLE */
/*  AS THE PREVIOUS POINT. IF YES, SKIP TO THE COMPUTATION */
/*  OF THE POLYNOMIAL */

	    if (*ix != *ixpv || *iy != *iypv) {
		*ixpv = *ix;
		*iypv = *iy;

/*  ROUTINES TO PICK UP NECESSARY X,Y, AND Z VALUES, TO */
/*  COMPUTE THE ZA, ZB AND ZAB VALUES, AND TO ESTIMATE THEM */

/*  WHEN NECESSARY */

		*jx = *ix;
		if (*jx == 1) {
		    *jx = 2;
		}
		if (*jx == *lxp1) {
		    *jx = *lx0;
		}
		*jy = *iy;
		if (*jy == 1) {
		    *jy = 2;
		}
		if (*jy == *lyp1) {
		    *jy = *ly0;
		}
		*jxm2 = *jx - 2;
		jxml = *jx - *lx0;
		*jym2 = *jy - 2;
		jyml = *jy - *ly0;

/*  IN THE CORE AREA, I.E., IN THE RECTANGLE THAT CONTAINS */
/*  THE DESIRED POINT */

		x3 = x[*jx - 1];
		*x4 = x[*jx];
		a3 = (float)1. / (*x4 - x3);
		y3 = y[*jy - 1];
		*y4 = y[*jy];
		b3 = (float)1. / (*y4 - y3);
		*z33 = z[*jx - 1 + (*jy - 1) * z_dim1];
		*z43 = z[*jx + (*jy - 1) * z_dim1];
		*z34 = z[*jx - 1 + *jy * z_dim1];
		*z44 = z[*jx + *jy * z_dim1];
		*z3a3 = (*z43 - *z33) * a3;
		*z4a3 = (*z44 - *z34) * a3;
		*z3b3 = (*z34 - *z33) * b3;
		*z4b3 = (*z44 - *z43) * b3;
		*za3b3 = (*z4b3 - *z3b3) * a3;

/*  IN THE X DIRECTION */

		if (*lxm2 == 0) {
		    *z3a2 = *z3a3;
		    *z4a2 = *z4a3;
		} else {
		    if (*jxm2 != 0) {
			*x2 = x[*jx - 2];
			*a2 = (float)1. / (x3 - *x2);
			*z23 = z[*jx - 2 + (*jy - 1) * z_dim1];
			*z24 = z[*jx - 2 + *jy * z_dim1];
			*z3a2 = (*z33 - *z23) * *a2;
			*z4a2 = (*z34 - *z24) * *a2;
			if (jxml == 0) {
			    goto L100;
			}
		    }
		    *x5 = x[*jx + 1];
		    *a4 = (float)1. / (*x5 - *x4);
		    *z53 = z[*jx + 1 + (*jy - 1) * z_dim1];
		    *z54 = z[*jx + 1 + *jy * z_dim1];
		    *z3a4 = (*z53 - *z43) * *a4;
		    *z4a4 = (*z54 - *z44) * *a4;
		    if (*jxm2 == 0) {
			*z3a2 = *z3a3 + *z3a3 - *z3a4;
			*z4a2 = *z4a3 + *z4a3 - *z4a4;
		    }
		    goto L110;
		}
L100:
		*z3a4 = *z3a3 + *z3a3 - *z3a2;
		*z4a4 = *z4a3 + *z4a3 - *z4a2;
L110:
		*za2b3 = (*z4a2 - *z3a2) * b3;
		*za4b3 = (*z4a4 - *z3a4) * b3;
		if (*jx <= 3) {
		    *z3a1 = *z3a2 + *z3a2 - *z3a3;
		    *z4a1 = *z4a2 + *z4a2 - *z4a3;
		} else {
		    *a1 = (float)1. / (*x2 - x[*jx - 3]);
		    *z3a1 = (*z23 - z[*jx - 3 + (*jy - 1) * z_dim1]) * *a1;
		    *z4a1 = (*z24 - z[*jx - 3 + *jy * z_dim1]) * *a1;
		}
		if (*jx >= *lxm1) {
		    *z3a5 = *z3a4 + *z3a4 - *z3a3;
		    *z4a5 = *z4a4 + *z4a4 - *z4a3;
		} else {
		    *a5 = (float)1. / (x[*jx + 2] - *x5);
		    *z3a5 = (z[*jx + 2 + (*jy - 1) * z_dim1] - *z53) * *a5;
		    *z4a5 = (z[*jx + 2 + *jy * z_dim1] - *z54) * *a5;
		}

/*  IN THE Y DIRECTION */

		if (*lym2 == 0) {
		    *z3b2 = *z3b3;
		    *z4b2 = *z4b3;
		} else {
		    if (*jym2 != 0) {
			*y2 = y[*jy - 2];
			*b2 = (float)1. / (y3 - *y2);
			*z32 = z[*jx - 1 + (*jy - 2) * z_dim1];
			*z42 = z[*jx + (*jy - 2) * z_dim1];
			*z3b2 = (*z33 - *z32) * *b2;
			*z4b2 = (*z43 - *z42) * *b2;
			if (jyml == 0) {
			    goto L120;
			}
		    }
		    *y5 = y[*jy + 1];
		    *b4 = (float)1. / (*y5 - *y4);
		    *z35 = z[*jx - 1 + (*jy + 1) * z_dim1];
		    *z45 = z[*jx + (*jy + 1) * z_dim1];
		    *z3b4 = (*z35 - *z34) * *b4;
		    *z4b4 = (*z45 - *z44) * *b4;
		    if (*jym2 == 0) {
			*z3b2 = *z3b3 + *z3b3 - *z3b4;
			*z4b2 = *z4b3 + *z4b3 - *z4b4;
		    }
		    goto L130;
		}
L120:
		*z3b4 = *z3b3 + *z3b3 - *z3b2;
		*z4b4 = *z4b3 + *z4b3 - *z4b2;
L130:
		*za3b2 = (*z4b2 - *z3b2) * a3;
		*za3b4 = (*z4b4 - *z3b4) * a3;
		if (*jy <= 3) {
		    *z3b1 = *z3b2 + *z3b2 - *z3b3;
		    *z4b1 = *z4b2 + *z4b2 - *z4b3;
		} else {
		    *b1 = (float)1. / (*y2 - y[*jy - 3]);
		    *z3b1 = (*z32 - z[*jx - 1 + (*jy - 3) * z_dim1]) * *b1;
		    *z4b1 = (*z42 - z[*jx + (*jy - 3) * z_dim1]) * *b1;
		}
		if (*jy >= *lym1) {
		    *z3b5 = *z3b4 + *z3b4 - *z3b3;
		    *z4b5 = *z4b4 + *z4b4 - *z4b3;
		} else {
		    *b5 = (float)1. / (y[*jy + 2] - *y5);
		    *z3b5 = (z[*jx - 1 + (*jy + 2) * z_dim1] - *z35) * *b5;
		    *z4b5 = (z[*jx + (*jy + 2) * z_dim1] - *z45) * *b5;
		}

/*  IN THE DIAGONAL DIRECTION */

		if (*lxm2 == 0) {
		    *za2b2 = *za3b2;
		    *za4b2 = *za3b2;
		    *za2b4 = *za3b4;
		    *za4b4 = *za3b4;
		} else if (*lym2 == 0) {
		    *za2b2 = *za2b3;
		    *za2b4 = *za2b3;
		    *za4b2 = *za4b3;
		    *za4b4 = *za4b3;
		} else {
		    if (jxml != 0) {
			if (*jym2 != 0) {
			    *za4b2 = ((*z53 - z[*jx + 1 + (*jy - 2) * z_dim1])
				     * *b2 - *z4b2) * *a4;
			    if (jyml == 0) {
				*za4b4 = *za4b3 + *za4b3 - *za4b2;
				goto L140;
			    }
			}
			*za4b4 = ((z[*jx + 1 + (*jy + 1) * z_dim1] - *z54) * *
				b4 - *z4b4) * *a4;
			if (*jym2 == 0) {
			    *za4b2 = *za4b3 + *za4b3 - *za4b4;
			}
L140:
			if (*jxm2 == 0) {
			    *za2b2 = *za3b2 + *za3b2 - *za4b2;
			    *za2b4 = *za3b4 + *za3b4 - *za4b4;
			    goto L150;
			}
		    }
		    if (*jym2 != 0) {
			*za2b2 = (*z3b2 - (*z23 - z[*jx - 2 + (*jy - 2) * 
				z_dim1]) * *b2) * *a2;
			if (jyml == 0) {
			    *za2b4 = *za2b3 + *za2b3 - *za2b2;
			    goto L160;
			}
		    }
		    *za2b4 = (*z3b4 - (z[*jx - 2 + (*jy + 1) * z_dim1] - *z24)
			     * *b4) * *a2;
		    if (*jym2 == 0) {
			*za2b2 = *za2b3 + *za2b3 - *za2b4;
		    }
L160:
		    if (jxml == 0) {
			*za4b2 = *za3b2 + *za3b2 - *za2b2;
			*za4b4 = *za3b4 + *za3b4 - *za2b4;
		    }
		}



/*  NUMERICAL DIFFERENTIATION  ---  TO DETERMINE PARTIAL */
/*  DERIVATIVES ZX, ZY, AND ZXY AS WEIGHTED MEANS OF DIVIDED 
    DIFFERENCES ZA, ZB, AND ZAB, RESPECTIVELY */


L150:
		for (*jy = 2; *jy <= 3; ++(*jy)) {
		    for (*jx = 2; *jx <= 3; ++(*jx)) {
			*w2 = (r__1 = za[*jx + 2 + (*jy - 1) * 5 - 6] - za[*
				jx + 1 + (*jy - 1) * 5 - 6], abs(r__1));
			*w3 = (r__1 = za[*jx + (*jy - 1) * 5 - 6] - za[*jx - 
				1 + (*jy - 1) * 5 - 6], abs(r__1));
			sw = *w2 + *w3;
			if (sw == (float)0.) {
			    *wx2 = (float).5;
			    *wx3 = (float).5;
			} else {
			    *wx2 = *w2 / sw;
			    *wx3 = *w3 / sw;
			}
			zx[*jx + (*jy << 2) - 5] = *wx2 * za[*jx + (*jy - 1) *
				 5 - 6] + *wx3 * za[*jx + 1 + (*jy - 1) * 5 - 
				6];
			*w2 = (r__1 = zb[*jx - 1 + (*jy + 2 << 1) - 3] - zb[*
				jx - 1 + (*jy + 1 << 1) - 3], abs(r__1));
			*w3 = (r__1 = zb[*jx - 1 + (*jy << 1) - 3] - zb[*jx - 
				1 + (*jy - 1 << 1) - 3], abs(r__1));
			sw = *w2 + *w3;
			if (sw == (float)0.) {
			    *wy2 = (float).5;
			    *wy3 = (float).5;
			} else {
			    *wy2 = *w2 / sw;
			    *wy3 = *w3 / sw;
			}
			zy[*jx + (*jy << 2) - 5] = *wy2 * zb[*jx - 1 + (*jy <<
				 1) - 3] + *wy3 * zb[*jx - 1 + (*jy + 1 << 1) 
				- 3];
			zxy[*jx + (*jy << 2) - 5] = *wy2 * (*wx2 * zab[*jx - 
				1 + (*jy - 1) * 3 - 4] + *wx3 * zab[*jx + (*
				jy - 1) * 3 - 4]) + *wy3 * (*wx2 * zab[*jx - 
				1 + *jy * 3 - 4] + *wx3 * zab[*jx + *jy * 3 - 
				4]);
/* L180: */
		    }
/* L170: */
		}

/*  WHEN (U(K).LT.X(1)).OR.(U(K).GT.X(LX)) */

		if (*ix == *lxp1) {
		    *w4 = *a2 * (a3 * (float)3. + *a2);
		    *w5 = a3 * (float)2. * (a3 - *a2) + *w4;
		    for (*jy = 2; *jy <= 3; ++(*jy)) {
			zx[(*jy << 2) - 1] = (*w4 * za[(*jy - 1) * 5 - 2] + *
				w5 * za[(*jy - 1) * 5 - 1]) / (*w4 + *w5);
			zy[(*jy << 2) - 1] = zy[(*jy << 2) - 2] + zy[(*jy << 
				2) - 2] - zy[(*jy << 2) - 3];
			zxy[(*jy << 2) - 1] = zxy[(*jy << 2) - 2] + zxy[(*jy 
				<< 2) - 2] - zxy[(*jy << 2) - 3];
			for (*jx = 2; *jx <= 3; ++(*jx)) {
			    zx[*jx + (*jy << 2) - 5] = zx[*jx + 1 + (*jy << 2)
				     - 5];
			    zy[*jx + (*jy << 2) - 5] = zy[*jx + 1 + (*jy << 2)
				     - 5];
			    zxy[*jx + (*jy << 2) - 5] = zxy[*jx + 1 + (*jy << 
				    2) - 5];
/* L200: */
			}
/* L190: */
		    }
		    x3 = *x4;
		    *z33 = *z43;
		    for (*jy = 1; *jy <= 5; ++(*jy)) {
			zb[(*jy << 1) - 2] = zb[(*jy << 1) - 1];
/* L210: */
		    }
		    a3 = *a2;
		    *jx = 3;
		} else if (*ix != 1) {
		    goto L220;
		} else {
		    *w2 = *a4 * (a3 * (float)3. + *a4);
		    *w1 = a3 * (float)2. * (a3 - *a4) + *w2;
		    for (*jy = 2; *jy <= 3; ++(*jy)) {
			zx[(*jy << 2) - 4] = (*w1 * za[(*jy - 1) * 5 - 5] + *
				w2 * za[(*jy - 1) * 5 - 4]) / (*w1 + *w2);
			zy[(*jy << 2) - 4] = zy[(*jy << 2) - 3] + zy[(*jy << 
				2) - 3] - zy[(*jy << 2) - 2];
			zxy[(*jy << 2) - 4] = zxy[(*jy << 2) - 3] + zxy[(*jy 
				<< 2) - 3] - zxy[(*jy << 2) - 2];
			for (*jx1 = 2; *jx1 <= 3; ++(*jx1)) {
			    *jx = 5 - *jx1;
			    zx[*jx + (*jy << 2) - 5] = zx[*jx - 1 + (*jy << 2)
				     - 5];
			    zy[*jx + (*jy << 2) - 5] = zy[*jx - 1 + (*jy << 2)
				     - 5];
			    zxy[*jx + (*jy << 2) - 5] = zxy[*jx - 1 + (*jy << 
				    2) - 5];
/* L240: */
			}
/* L230: */
		    }
		    x3 -= (float)1. / *a4;
		    *z33 -= *z3a2 / *a4;
		    for (*jy = 1; *jy <= 5; ++(*jy)) {
			zb[(*jy << 1) - 1] = zb[(*jy << 1) - 2];
/* L250: */
		    }
		    for (*jy = 2; *jy <= 4; ++(*jy)) {
			zb[(*jy << 1) - 2] -= zab[(*jy - 1) * 3 - 3] / *a4;
/* L260: */
		    }
		    a3 = *a4;
		    *jx = 1;
		}
		za[2] = za[*jx];
		for (*jy = 1; *jy <= 3; ++(*jy)) {
		    zab[*jy * 3 - 2] = zab[*jx + *jy * 3 - 4];
/* L270: */
		}

/*  WHEN (V(K).LT.Y(1)).OR.(V(K).GT.Y(LY)) */

L220:
		if (*iy == *lyp1) {
		    *w4 = *b2 * (b3 * (float)3. + *b2);
		    *w5 = b3 * (float)2. * (b3 - *b2) + *w4;
		    for (*jx = 2; *jx <= 3; ++(*jx)) {
			if (*jx != 3 || *ix != *lxp1) {
			    if (*jx != 2 || *ix != 1) {
				zy[*jx + 11] = (*w4 * zb[*jx + 4] + *w5 * zb[*
					jx + 6]) / (*w4 + *w5);
				zx[*jx + 11] = zx[*jx + 7] + zx[*jx + 7] - zx[
					*jx + 3];
				zxy[*jx + 11] = zxy[*jx + 7] + zxy[*jx + 7] - 
					zxy[*jx + 3];
			    }
			}
			for (*jy = 2; *jy <= 3; ++(*jy)) {
			    zy[*jx + (*jy << 2) - 5] = zy[*jx + (*jy + 1 << 2)
				     - 5];
			    zx[*jx + (*jy << 2) - 5] = zx[*jx + (*jy + 1 << 2)
				     - 5];
			    zxy[*jx + (*jy << 2) - 5] = zxy[*jx + (*jy + 1 << 
				    2) - 5];
/* L290: */
			}
/* L280: */
		    }
		    y3 = *y4;
		    *z33 += *z3b3 / b3;
		    *z3a3 += *za3b3 / b3;
		    *z3b3 = *z3b4;
		    *za3b3 = *za3b4;
		    b3 = *b2;
		} else if (*iy != 1) {
		    goto L300;
		} else {
		    *w2 = *b4 * (b3 * (float)3. + *b4);
		    *w1 = b3 * (float)2. * (b3 - *b4) + *w2;
		    for (*jx = 2; *jx <= 3; ++(*jx)) {
			if (*jx != 3 || *ix != *lxp1) {
			    if (*jx != 2 || *ix != 1) {
				zy[*jx - 1] = (*w1 * zb[*jx - 2] + *w2 * zb[*
					jx]) / (*w1 + *w2);
				zx[*jx - 1] = zx[*jx + 3] + zx[*jx + 3] - zx[*
					jx + 7];
				zxy[*jx - 1] = zxy[*jx + 3] + zxy[*jx + 3] - 
					zxy[*jx + 7];
			    }
			}
			for (*jy1 = 2; *jy1 <= 3; ++(*jy1)) {
			    *jy = 5 - *jy1;
			    zy[*jx + (*jy << 2) - 5] = zy[*jx + (*jy - 1 << 2)
				     - 5];
			    zx[*jx + (*jy << 2) - 5] = zx[*jx + (*jy - 1 << 2)
				     - 5];
			    zxy[*jx + (*jy << 2) - 5] = zxy[*jx + (*jy - 1 << 
				    2) - 5];
/* L320: */
			}
/* L310: */
		    }
		    y3 -= (float)1. / *b4;
		    *z33 -= *z3b2 / *b4;
		    *z3a3 -= *za3b2 / *b4;
		    *z3b3 = *z3b2;
		    *za3b3 = *za3b2;
		    b3 = *b4;
		}
		if (*ix == 1 || *ix == *lxp1) {
		    *jx = *ix / *lxp1 + 2;
		    *jx1 = 5 - *jx;
		    *jy = *iy / *lyp1 + 2;
		    *jy1 = 5 - *jy;
		    zx[*jx + (*jy << 2) - 5] = zx[*jx1 + (*jy << 2) - 5] + zx[
			    *jx + (*jy1 << 2) - 5] - zx[*jx1 + (*jy1 << 2) - 
			    5];
		    zy[*jx + (*jy << 2) - 5] = zy[*jx1 + (*jy << 2) - 5] + zy[
			    *jx + (*jy1 << 2) - 5] - zy[*jx1 + (*jy1 << 2) - 
			    5];
		    zxy[*jx + (*jy << 2) - 5] = zxy[*jx1 + (*jy << 2) - 5] + 
			    zxy[*jx + (*jy1 << 2) - 5] - zxy[*jx1 + (*jy1 << 
			    2) - 5];
		}

/*  DETERMINATION OF THE COEFFICIENTS OF THE POLYNOMIAL */

L300:
		zx3b3 = (*zx34 - *zx33) * b3;
		zx4b3 = (*zx44 - *zx43) * b3;
		zy3a3 = (*zy43 - *zy33) * a3;
		zy4a3 = (*zy44 - *zy34) * a3;
		*a = *za3b3 - zx3b3 - zy3a3 + *zxy33;
		*b = zx4b3 - zx3b3 - *zxy43 + *zxy33;
		*c = zy4a3 - zy3a3 - *zxy34 + *zxy33;
		*d = *zxy44 - *zxy43 - *zxy34 + *zxy33;
		*e = *a + *a - *b - *c;
		*a3sq = a3 * a3;
		*b3sq = b3 * b3;
		*p02 = ((*z3b3 - *zy33) * (float)2. + *z3b3 - *zy34) * b3;
		*p03 = (*z3b3 * (float)-2. + *zy34 + *zy33) * *b3sq;
		*p12 = ((zx3b3 - *zxy33) * (float)2. + zx3b3 - *zxy34) * b3;
		*p13 = (zx3b3 * (float)-2. + *zxy34 + *zxy33) * *b3sq;
		*p20 = ((*z3a3 - *zx33) * (float)2. + *z3a3 - *zx43) * a3;
		*p21 = ((zy3a3 - *zxy33) * (float)2. + zy3a3 - *zxy43) * a3;
		*p22 = ((*a + *e) * (float)3. + *d) * a3 * b3;
		*p23 = (*e * (float)-3. - *b - *d) * a3 * *b3sq;
		*p30 = (*z3a3 * (float)-2. + *zx43 + *zx33) * *a3sq;
		*p31 = (zy3a3 * (float)-2. + *zxy43 + *zxy33) * *a3sq;
		*p32 = (*e * (float)-3. - *c - *d) * b3 * *a3sq;
		*p33 = (*d + *e + *e) * *a3sq * *b3sq;
	    }

/*  COMPUTATION OF THE POLYNOMIAL */

	    *dy = *vk - y3;
	    *q0 = *p00 + *dy * (*p01 + *dy * (*p02 + *dy * *p03));
	    *q1 = *p10 + *dy * (*p11 + *dy * (*p12 + *dy * *p13));
	    *q2 = *p20 + *dy * (*p21 + *dy * (*p22 + *dy * *p23));
	    *q3 = *p30 + *dy * (*p31 + *dy * (*p32 + *dy * *p33));
	    *dx = *uk - x3;
	    w[k] = *q0 + *dx * (*q1 + *dx * (*q2 + *dx * *q3));
	    r0 = *q1;
	    r1 = *q2 * (float)2.;
	    r2 = *q3 * (float)3.;
	    wx[k] = r0 + *dx * (r1 + *dx * r2);
	    qq1 = *p01 + *dx * (*p11 + *dx * (*p21 + *dx * *p31));
	    qq2 = *p02 + *dx * (*p12 + *dx * (*p22 + *dx * *p32));
	    qq3 = *p03 + *dx * (*p13 + *dx * (*p23 + *dx * *p33));
	    s0 = qq1;
	    s1 = qq2 * (float)2.;
	    s2 = qq3 * (float)3.;
	    wy[k] = s0 + *dy * (s1 + *dy * s2);

/*         DEFINITION OF COORDINATES FOR INTERFACE TO FARBRC */
	    
  if (itas != -100  &&
      *ix <= *lx0 && *ix > 1 &&
      *iy <= *ly0 && *iy > 1   ) {
 
/****  call to farbrc_ */
       ++rect_counter;
	    xx[0] = x[*ix];
	    xx[1] = x[*ix-1];
	    xx[2] = x[*ix-1];
	    xx[3] = x[*ix];
	    yy[0] = y[*iy];
	    yy[1] = y[*iy];
	    yy[2] = y[*iy-1];
	    yy[3] = y[*iy-1];
	    zz[0] = z[*ix + *iy * z_dim1];
	    zz[1] = z[*ix - 1 + *iy * z_dim1];
            zz[2] = z[*ix - 1 + (*iy - 1) * z_dim1];
	    zz[3] = z[*ix + (*iy - 1) * z_dim1];
	    zzx[0] = *zx44;
	    zzy[0] = *zy44;
	    zzxy[0] = *zxy44;
	    zzx[1] = *zx34;
	    zzy[1] = *zy34;
	    zzxy[1] = *zxy34;
	    zzx[2] = *zx33;
	    zzy[2] = *zy33;
	    zzxy[2] = *zxy33;
	    zzx[3] = *zx43;
	    zzy[3] = *zy43;
	    zzxy[3] = *zxy43;

            nsides = 4;
	    farbrc_(xx, yy, zz, zzx, zzy, zzxy, cn, &icol[1],
                    nc, itask, 
		    &nsides, &rect_counter, usrpsc_);  
	}
   }
/*  NORMAL EXIT */

	return 0;
L60:
        fprintf (stderr, fmt_9070);
	goto L330;
L50:
        fprintf (stderr, fmt_9060);
L330:
        fprintf (stderr, fmt_9080,*iy,y[*iy]);
	goto L340;
L30:
        fprintf (stderr, fmt_9040);
	goto L350;
L20:
        fprintf (stderr, fmt_9030);
L350:
        fprintf (stderr, fmt_9050,*ix,x[*ix]);
    }
L340:
        fprintf (stderr, fmt_9090,*lx0,*ly0,n0);

} /* itplbv_ */

#undef jym2
#undef lyp1
#undef lym2
#undef lxp1
#undef lym1
#undef lxm2
#undef lxm1
#undef jxm2
#undef b3sq
#undef a3sq
#undef zxy
#undef zy44
#undef zy34
#undef zy43
#undef zy33
#undef zx44
#undef zx34
#undef zx43
#undef zx33
#undef imx
#undef imn
#undef z4b5
#undef z4b4
#undef z4b3
#undef z4b2
#undef z4b1
#undef z3b5
#undef z3b4
#undef z3b3
#undef z3b2
#undef z3b1
#undef z4a5
#undef z4a4
#undef z4a3
#undef z4a2
#undef z4a1
#undef z3a5
#undef z3a4
#undef z3a3
#undef z3a2
#undef z3a1
#undef zab
#undef wx3
#undef wy3
#undef wy2
#undef wx2
#undef jy1
#undef ly0
#undef lx0
#undef jx1
#undef p33
#undef z54
#undef p32
#undef z53
#undef p31
#undef z45
#undef p30
#undef z44
#undef p23
#undef zy
#undef zx
#undef z43
#undef z42
#undef z35
#undef z34
#undef z32
#undef z24
#undef z23
#undef vk
#undef uk
#undef jy
#undef jx
#undef iy
#undef ix
#undef z33
#undef dy
#undef dx
#undef zb
#undef za
#undef p22
#undef p21
#undef p20
#undef p13
#undef p12
#undef p03
#undef p02
#undef p11
#undef p10
#undef p01
#undef p00
#undef w5
#undef w3
#undef w4
#undef y5
#undef y4
#undef x5
#undef x4
#undef y2
#undef x2
#undef w2
#undef w1
#undef q3
#undef q2
#undef q1
#undef q0
#undef b4
#undef b2
#undef b5
#undef a5
#undef a4
#undef a2
#undef b1
#undef a1
#undef e
#undef d
#undef c
#undef b
#undef a
#undef zxy44
#undef zxy34
#undef zxy43
#undef zxy33
#undef iypv
#undef ixpv
#undef za4b4
#undef za3b4
#undef za2b4
#undef za4b3
#undef za3b3
#undef za2b3
#undef za4b2
#undef za3b2
#undef za2b2
