/* Copyright (C) A.Preusser, Fritz-Haber-Inst. der MPG, 1993, 1994 */
#include <stdio.h>
#include <time.h>
#include <X11/Intrinsic.h>	
#include <X11/StringDefs.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
	
#define NCOL 254     /* No. of colors limited to 256 here */
#define NDEFCOL 33   /* Default colors*/
static FILE *psp;    /* pointer to postscript file */
static int icol;     /* Color index */
static int line_width[3];/*line width in cm/1000 for gslwsc_ps*/
static int char_height[3]; /* character heights in cm/100 */

extern int start_of_symb_colors; 

extern void prolog_ps(w,col,ncol,lwidth,cheight)
        Widget w;
        Pixel col[NCOL+3+NDEFCOL+8]; 
        int ncol;
        int lwidth[], cheight[];
{ 
        XWindowAttributes win_attr;
        XColor xcol[NCOL+3+NDEFCOL+8];
        Colormap cm;
        int i, color_table_length, win_col_tab_len;
        float red,green,blue;

        line_width[0]= lwidth[0];
        line_width[1]= lwidth[1];
        line_width[2]= lwidth[2];

        char_height[0]= cheight[0];
        char_height[1]= cheight[1];
        char_height[2]= cheight[2];

        color_table_length= NCOL+3+NDEFCOL+8;         

        fprintf (psp,"\
/RedAr  %d array def \n\
/GreAr  %d array def \n\
/BluAr  %d array def \n\
\n\
/SCR  { %% Set Color Representation \n\
        %% Stack: Red, Green, Blue, Index \n\
/ind exch def \n\
BluAr ind 3 2 roll put \n\
GreAr ind 3 2 roll put \n\
RedAr ind 3 2 roll put \n\
            } bind def \n\
\n\
/SCI { %% Set Color Index \n\
       %% Stack: index \n\
/ind exch def \n\
/red RedAr ind get def \n\
/gre GreAr ind get def \n\
/blu BluAr ind get def \n\
red gre blu setrgbcolor} bind def \n\
\n\
/FSD {findfont exch scalefont def} bind def \n\
\n\
/S1 %.2f /Courier-Bold FSD \n\
/S2 %.2f /Courier-Bold FSD \n\
/S3 %.2f /Courier-Bold FSD \n\
\n\
/F1 {%.2f S1} bind def \n\
/F2 {%.2f S2} bind def \n\
/F3 {%.2f S3} bind def \n\
\n\
", color_table_length,color_table_length,color_table_length,
   cheight[0]*0.01, cheight[1]*0.01, cheight[2]*0.01,
   cheight[0]*0.01, cheight[1]*0.01, cheight[2]*0.01);

fprintf (psp,"\
/BOX { %% Clear Background \n\
       %% Stack: dx, dy, string, backcolor \n\
   gsave %% saving currentpoint \n\
   0 -0.05 rmoveto 0.76 mul 0.05 add %% modify rectangle \n\
   dup neg 3 1 roll \n\
   0 exch rlineto 0 rlineto 0 exch rlineto \n\
   closepath exch SCI fill grestore} bind def \n\
\n\
/T { %% Text \n\
     %% Stack: color, backcolor, rel. x pos,\n\
     %%        string, height, x, y \n\
    moveto setfont exch dup stringwidth pop \n\
    dup 5 -1 roll mul neg 0 rmoveto \n\
    3 2 roll BOX exch SCI show} bind def \n\
\n\
/StackW 1 array def \n\
/W {%%def copy rel moves starting at [ from stack to StackW \n\
   ] /StackW exch def   %% read from stack into StackW \n\
   StackW aload pop     %% copy back to stack \n\
   } bind def \n\
\n\
/R {%%def Read from StackR in inverse order \n\
    StackR length 2 sub -2 0 %% loop parameters \n\
    {dup StackR exch get neg  %% get x \n\
     exch StackR exch 1 add get neg} %% get y \n\
    for \n\
   } bind def \n\
\n\
/F {%%def take color index, one abs move \n\
    %%         and relative moves from stack \n\
    %%         and fill \n\
    SCI    %% set color index \n\
    moveto %% abs move in cm \n\
    0.001 0.001 scale  %% rel moves in 1/1000 cm \n\
    count -2 2 { \n\
    pop rlineto} for \n\
    closepath \n\
    fill \n\
    /StackR StackW def       %% copy StackW to StackR \n\
    1000 1000 scale    %% back to cm \n\
   } bind def \n\
\n\
/L {%%def Polyline, similar to F\n\
    SCI \n\
    moveto \n\
    0.001 0.001 scale \n\
    count -2 2 { \n\
    pop rlineto     } for \n\
    stroke \n\
    1000 1000 scale } bind def \n\
\n\
/RS {%%def \n\
     restore save } bind def \n\
\n\
");

/**** query RGB-values of colors  ****/
   xcol[0].pixel= 0;
   for (i=1; i<=ncol; i++){
      xcol[i].pixel= col[i];
/*      printf("i, col[i], %d %d \n", i, col[i]); */
   }

   XGetWindowAttributes(XtDisplay(w),XtWindow(w),&win_attr);
 
   XQueryColors(XtDisplay(w),
   win_attr.colormap,
   xcol, ncol+1);
       
/**** color 0 is always black ****/
   xcol[0].red= 0.; xcol[0].green= 0.; xcol[0].blue= 0.;

/**** write color table to postscript file ****/
   for (i=0;i<=ncol;i++) {
      red= xcol[i].red/65280. ;
      if (red > 1.) red= 1. ;
      green= xcol[i].green/65280. ;
      if (green > 1.) green= 1. ;
      blue= xcol[i].blue/65280. ;
      if (blue > 1.) blue= 1. ;
      if (i == start_of_symb_colors + NDEFCOL -1) {
          red= 1.; green= 1.; blue= 1.;}
      fprintf (psp,"%7.4f %7.4f %7.4f %d SCR\n",
              red,green,blue,i);
   }
   fprintf (psp,"%%%%EndProlog\n\n");

/*** set initial line width (for contour lines) ***/
   fprintf (psp," %d setlinewidth\n",line_width[0]);

   fprintf (psp,"save\n");
}
/* ======================================================== */
extern void gslwsc_ps(i)
	int i;
{
/* set line width in cm/1000 */
        fprintf (psp,"%d setlinewidth\n",line_width[i]); 
}
/* ======================================================== */
extern void gsfai_ps(i)
	int *i;
{
/* set color index */
/*        fprintf (psp,"%d SCI\n",*i); */
        icol= *i;
}
/* ======================================================== */
extern void gwatch_ps(i)
	int i;
{/* restore for postscript garbage collection */
        fprintf (psp,"RS\n");
        fprintf (stderr, "."); 
}
/* ======================================================== */
extern void gfa_ps(n,x,y,
         jpolr, npolr, nride, jfrst, jtost)

	int *n;
	float *x,*y;
        int *jpolr,*npolr,*nride,*jfrst,*jtost;

/* Fill Area for Postscript 
---------------------------- */

/* This routine is supplied with a fill polygon and
   information about parts of this polygon that are
   to be written to, or read from a stack. Input
   coordinates are in cm */

/* It writes a ASCII-output (part of postscript-file)
   with relative moves and interspersed marks for
   writing and reading to/from a stack. [ W are marks
   for writing the moves in between. R is a sign for
   reading. The relative moves are in cm/1000. */

/*      n               number of points 
        x,y             coordinates of points
        nride           number of rides; iride=1,...,nride 
        jpolr[iride-1]  start of ride iride in x and y
        npolr[iride-1]  number of points for ride iride
        jfrst[iride-1]  stack no. from which iride can be copied
                        if zero, no copy
        jtost[iride-1]  stack no. to which iride must be copied
                        if zero, no copy 
*/
{
	register int i,ixdif,iydif;
        register float xcur,ycur;
        int jfr, jto, npolfr, npolto, jpolfr, jpolto, jprint;

/*      consider only stack no. 1 */        
        jfr= 0; jto= 0;
        for (i=1;i<=*nride;i++) {
           if (jfrst[i-1]==1) jfr= i;
           if (jtost[i-1]==1) jto= i; }
/*      jfr, jto = ride no. to be copied or to be written
                   to stack no. 1 */

        npolfr= 0; npolto= 0;
        if (jfr!=0) {jpolfr= jpolr[jfr-1];
                     npolfr= npolr[jfr-1];}
        if (jto!=0) {jpolto= jpolr[jto-1];
                     npolto= npolr[jto-1];}
/*      jpolfr, jpolto= index in x,y for start of ride */
/*      npolfr, npolto= number of points of ride */

        xcur= x[1]*1000; ycur= y[1]*1000;
        jprint= 0;
        for (i=2;i<=*n;i++) {
           ixdif= xcur-x[i]*1000;
           iydif= ycur-y[i]*1000;

/*         check, if write to stack */
           if (npolto!=0 && i-1==jpolto) fprintf (psp,"[");

/*         check if moves can be copied from stack */
           if (npolfr==0 ||
               npolfr!=0 && i-1<jpolfr ||
               npolfr!=0 && i>jpolfr+npolfr-1)     {
             fprintf (psp,"%d %d ", ixdif,iydif);
               jprint++;
/*             add newline */
               if (jprint%6==0) fprintf (psp,"\n");}

/*         check for copy (reading) from stack */                       
           if (npolfr!=0 && i-1==jpolfr)
             fprintf (psp,"R ");
 
/*         check if write to stack ended */
           if (npolto!=0 && jpolto+npolto-1==i)    
               fprintf (psp,"W ");

           xcur= xcur - ixdif;
           ycur= ycur - iydif; }

/*      print last point as reference point
              and color index */
        fprintf (psp,"%.3f %.3f %d F\n", x[*n],y[*n],icol);
}
/* ======================================================== */
extern void gpl_ps(n,x,y)
	int *n;
	float *x,*y;

{	register int i,ixdif,iydif;
        register float xcur,ycur;
--x;
--y;
        xcur= x[1]*1000; ycur= y[1]*1000;
        for (i=2;i<=*n;i++) {
           ixdif= xcur-x[i]*1000;
           iydif= ycur-y[i]*1000;
           fprintf (psp,"%d %d ", ixdif,iydif);
           if ((i-1)%6==0) fprintf (psp,"\n");
           xcur= xcur - ixdif;
           ycur= ycur - iydif; }
        fprintf (psp,"%.3f %.3f 0 L\n", x[*n],y[*n]);
}
/*****************************************************/
extern void gtext_ps(x, y, h, text, w, centerx, centery, color,
                     back_color, n)
	float *x, *y;
	char text[];
	float w, centerx, centery;
	int *n, h, color, back_color;
{
 float xx,yy;

        if (h==1) {       yy= *y - centery*char_height[0]*0.007;
          fprintf (psp,"%d %d %.1f (%s) \n F1 %.3f %.3f T\n",
                       color, back_color, centerx,text,*x,yy);}
        else if (h==2) {yy= *y - centery*char_height[1]*0.007;
          fprintf (psp,"%d %d %.1f (%s) \n F2 %.3f %.3f T\n",
                       color, back_color, centerx,text,*x,yy);}
        else {          yy= *y - centery*char_height[2]*0.007;
          fprintf (psp,"%d %d %.1f (%s) \n F3 %.3f %.3f T\n",
                       color, back_color, centerx,text,*x,yy);}
}
/*****************************************************/
void close_ps() 
{fprintf(psp,"restore\n\
showpage\n\
%%%%EOF\n");
fclose(psp);}
/*****************************************************/
a3_ps(psfile)
        char  *psfile;
{
        FILE  *fopen();
        time_t tp;

/* open FILE filnam */
        if ((psp= fopen(psfile, "w")) == NULL) {
           fprintf (stderr, "Unable to open %s\n",
                    psfile);
           return; }
tp= time(&tp);
fprintf(psp, "%%!PS-Adobe-1.0\n\
%%%%BoundingBox: 10 10 816 1163 \n\
%%%%Creator: A.Preusser FHI Berlin\n\
%%%%Title: xfarbe.ps\n\
%%%%CreationDate: %s\
%%%%Pages: 1\n\
%%%%DocumentFonts: Courier-Bold\n\
%%%%DocumentNeededFonts: Courier-Bold\n\
%%%%EndComments\n\
%% bounding box is for DIN A3 landscape\n\
%%%%BeginProlog\n\
\n\
 28.346 28.346 scale %% to cm \n\
 20.4 0.4 translate \n\
 90 rotate %% for landscape \n\
",
ctime(&tp));
fprintf(psp, "1.414 1.414 scale %% to A3\n");
}
/*****************************************************/
a4_ps(psfile)
        char  *psfile;
{
        FILE  *fopen();
        time_t tp;

/* open FILE filnam */
        if ((psp= fopen(psfile, "w")) == NULL) {
           fprintf (stderr, "Unable to open %s\n",
                    psfile);
           return; }
tp= time(&tp);
fprintf(psp, "%%!PS-Adobe-1.0\n\
%%%%BoundingBox: 10 10 577 822\n\
%%%%Creator: A.Preusser FHI Berlin\n\
%%%%Title: xfarbe.ps\n\
%%%%CreationDate: %s\
%%%%Pages: 1\n\
%%%%DocumentFonts: Courier-Bold\n\
%%%%DocumentNeededFonts: Courier-Bold\n\
%%%%EndComments\n\
%% bounding box is for DIN A4 landscape\n\
%%%%BeginProlog\n\
\n\
 28.346 28.346 scale %% to cm \n\
 20.4 0.4 translate \n\
 90 rotate %% for landscape \n\
",
ctime(&tp));
}

a4_port_ps(psfile)
        char  *psfile;
{
        FILE  *fopen();
        time_t tp;

/* open FILE filnam */
        if ((psp= fopen(psfile, "w")) == NULL) {
           fprintf (stderr, "Unable to open %s\n",
                    psfile);
           return; }
tp= time(&tp);
fprintf(psp, "%%!PS-Adobe-1.0\n\
%%%%BoundingBox: 10 10 582 412 \n\
%%%%Creator: A.Preusser FHI Berlin\n\
%%%%Title: xfarbe.ps\n\
%%%%CreationDate: %s\
%%%%Pages: 1\n\
%%%%DocumentFonts: Courier-Bold\n\
%%%%DocumentNeededFonts: Courier-Bold\n\
%%%%EndComments\n\
%% bounding box is for 1/2 DIN A4 portrait\n\
%%%%BeginProlog\n\
\n\
 28.346 28.346 scale %% to cm \n\
 0.4 0.4 translate \n\
 0.707 0.707 scale \n\
",
ctime(&tp));
}
